#property copyright "Copyright  2005, Jason Robinson (jnrtrading)"
#property link      "http://www.jnrtrading.co.uk"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LightSkyBlue
#property indicator_color2 Red

double g_ibuf_76[];
double g_ibuf_80[];
extern int FastMAPeriod = 5;
extern int FastMAMethod = 3;
extern int FastMAPrice = 0;
extern int SlowMAPeriod = 6;
extern int SlowMAMethod = 3;
extern int SlowMAPrice = 0;
extern bool Confirm = TRUE;
double gd_112;

int init() {
   gd_112 = Point * PTA(Period());
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, g_ibuf_76);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, g_ibuf_80);
   SetIndexLabel(0, "Cross Up");
   SetIndexLabel(1, "Cross Dn");
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   double l_ima_8;
   double l_ima_16;
   double l_ima_24;
   double l_ima_32;
   double l_ima_40;
   double l_ima_48;
   int li_0 = Bars - IndicatorCounted();
   if (Confirm) {
      for (int li_4 = 0; li_4 <= li_0; li_4++) {
         l_ima_8 = iMA(NULL, 0, FastMAPeriod, 0, FastMAMethod, FastMAPrice, li_4);
         l_ima_16 = iMA(NULL, 0, FastMAPeriod, 0, FastMAMethod, FastMAPrice, li_4 + 1);
         l_ima_24 = iMA(NULL, 0, FastMAPeriod, 0, FastMAMethod, FastMAPrice, li_4 + 2);
         l_ima_32 = iMA(NULL, 0, SlowMAPeriod, 0, SlowMAMethod, SlowMAPrice, li_4);
         l_ima_40 = iMA(NULL, 0, SlowMAPeriod, 0, SlowMAMethod, SlowMAPrice, li_4 + 1);
         l_ima_48 = iMA(NULL, 0, SlowMAPeriod, 0, SlowMAMethod, SlowMAPrice, li_4 + 2);
         g_ibuf_76[li_4] = EMPTY_VALUE;
         g_ibuf_80[li_4] = EMPTY_VALUE;
         if (l_ima_16 > l_ima_40 && l_ima_24 <= l_ima_48 && l_ima_8 > l_ima_32) g_ibuf_76[li_4] = Low[li_4] - gd_112;
         if (l_ima_16 < l_ima_40 && l_ima_24 >= l_ima_48 && l_ima_8 < l_ima_32) g_ibuf_80[li_4] = High[li_4] + gd_112;
      }
   } else {
      for (li_4 = 0; li_4 <= li_0; li_4++) {
         l_ima_8 = iMA(NULL, 0, FastMAPeriod, 0, FastMAMethod, FastMAPrice, li_4);
         l_ima_16 = iMA(NULL, 0, FastMAPeriod, 0, FastMAMethod, FastMAPrice, li_4 + 1);
         l_ima_32 = iMA(NULL, 0, SlowMAPeriod, 0, SlowMAMethod, SlowMAPrice, li_4);
         l_ima_40 = iMA(NULL, 0, SlowMAPeriod, 0, SlowMAMethod, SlowMAPrice, li_4 + 1);
         g_ibuf_76[li_4] = EMPTY_VALUE;
         g_ibuf_80[li_4] = EMPTY_VALUE;
         if (l_ima_8 > l_ima_32 && l_ima_16 <= l_ima_40) g_ibuf_76[li_4] = Low[li_4] - gd_112;
         if (l_ima_8 < l_ima_32 && l_ima_16 >= l_ima_40) g_ibuf_80[li_4] = High[li_4] + gd_112;
      }
   }
   return (0);
}

int PTA(int ai_0) {
   switch (ai_0) {
   case 1:
      return (4);
   case 5:
      return (6);
   case 15:
      return (8);
   case 30:
      return (13);
   case 60:
      return (17);
   case 240:
      return (40);
   case 1440:
      return (70);
   case 10080:
      return (150);
   case 43200:
      return (300);
   }
   return (0);
}
