#property copyright "*"
#property link      "*"

extern int TimeFrame = 0;
extern string s0 = "===  ==========================================================================================";
extern double Lots = 0.1;
extern bool FixedLots = TRUE;
extern double Risk = 0.5;
extern int MeansType = 1;
extern bool UseKeepingRest = FALSE;
extern double KeepingRest = 5000.0;
extern bool IncreaseKeepingRest = FALSE;
extern double IncreasePercents = 15.0;
extern datetime OrdersFrom = 0;
extern string s1 = "===  ==========================================================================================";
extern int Slippage = 3;
extern int StopLoss = 50;
extern int TakeProfit = 20;
extern int Magic_N = 32562;
extern string s2 = "===   ==========================================================================================";
extern int MaxCount = 1;
extern int MaxBuyCount = 1;
extern int MaxSellCount = 1;
extern bool CloseOnRev = FALSE;
extern bool UseCloseSig = FALSE;
extern string s3 = "===    ==========================================================================================";
extern bool UseCloseNoProfit = FALSE;
extern int ExpireBars = 90;
extern int MinProfitLevel = 5;
extern string s4 = "===  ==========================================================================================";
extern int TSTP_PriceStep = 10;
extern double TSTP_Minimal = 30.0;
extern bool TP_ON = FALSE;
extern bool TS_ON = FALSE;
extern int TS_StartInProfit = 0;
extern bool TS_UseStartInProfit = FALSE;
extern double TS_SLStep_K = 1.2;
extern string s5 = "===   ===============================================================================";
extern bool TrailingStop_Use = FALSE;
extern int TrailingStopStart = 15;
extern int TrailingStop = 15;
extern string s6 = "===  ==========================================================================================";
extern bool LBreakEven_Use = FALSE;
extern int LBreakEvenStart = 15;
extern int LBreakEvenLevel = 15;
extern string s7 = "===    ===============================================================================";
extern bool TrailingProf_Use = FALSE;
extern int TrailingProfStart = 15;
extern int TrailingProf = 15;
extern string s8 = "===   ==========================================================================================";
extern bool PBreakEven_Use = FALSE;
extern int PBreakEvenStart = 15;
extern int PBreakEvenLevel = 15;
extern string s9 = "====  ( ) ================================================================================================";
extern int E_FastMAPeriod = 5;
extern int E_FastMAMethod = 3;
extern int E_FastMAPrice = 0;
extern int E_SlowMAPeriod = 6;
extern int E_SlowMAMethod = 3;
extern int E_SlowMAPrice = 0;
extern bool E_Confirm = TRUE;
extern int T_ID = 1;
extern int T_FastMA_Period = 12;
extern int T_FastMA_Method = 1;
extern int T_FastMA_Price = 0;
extern int T_SlowMA_Period = 26;
extern int T_SlowMA_Method = 1;
extern int T_SlowMA_Price = 0;
extern int T_SignalMA_Period = 9;
extern int T_SignalMA_Method = 0;
extern int T_MAPeriod = 13;
extern int T_MAMethod = 1;
extern int T_MAPrice = 0;
extern bool T_Level_1_Check = FALSE;
extern double T_Level_1_Value = 0.0;
extern bool T_Level_2_Check = FALSE;
extern double T_Level_2_Value = 0.0;
extern bool T_ValFromSignal = FALSE;
extern bool BuyOnGreen = TRUE;
extern bool BuyOnChoc = TRUE;
extern bool BuyOnRed = FALSE;
extern bool BuyOnBlue = TRUE;
extern bool SellOnGreen = FALSE;
extern bool SellOnChoc = TRUE;
extern bool SellOnRed = TRUE;
extern bool SellOnBlue = TRUE;
extern int ArrowNumFrom = 1;
extern int ArrowNumTo = 0;
extern int FF_On = 1;
extern int FF_Period = 13;
extern int FF_MAMethod = 0;
extern int FF_Price = 0;
extern double FF_Level = 0.06;
extern string s10 = "====  ( ) ================================================================================================";
extern int cE_FastMAPeriod = 5;
extern int cE_FastMAMethod = 3;
extern int cE_FastMAPrice = 0;
extern int cE_SlowMAPeriod = 6;
extern int cE_SlowMAMethod = 3;
extern int cE_SlowMAPrice = 0;
extern bool cE_Confirm = TRUE;
extern int cT_ID = 1;
extern int cT_FastMA_Period = 12;
extern int cT_FastMA_Method = 1;
extern int cT_FastMA_Price = 0;
extern int cT_SlowMA_Period = 26;
extern int cT_SlowMA_Method = 1;
extern int cT_SlowMA_Price = 0;
extern int cT_SignalMA_Period = 9;
extern int cT_SignalMA_Method = 0;
extern int cT_MAPeriod = 13;
extern int cT_MAMethod = 1;
extern int cT_MAPrice = 0;
extern bool cT_Level_1_Check = FALSE;
extern double cT_Level_1_Value = 0.0;
extern bool cT_Level_2_Check = FALSE;
extern double cT_Level_2_Value = 0.0;
extern bool cT_ValFromSignal = FALSE;
extern bool cBuyOnGreen = TRUE;
extern bool cBuyOnChoc = TRUE;
extern bool cBuyOnRed = FALSE;
extern bool cBuyOnBlue = TRUE;
extern bool cSellOnGreen = FALSE;
extern bool cSellOnChoc = TRUE;
extern bool cSellOnRed = TRUE;
extern bool cSellOnBlue = TRUE;
extern int cArrowNumFrom = 1;
extern int cArrowNumTo = 0;
extern int cFF_On = 1;
extern int cFF_Period = 13;
extern int cFF_MAMethod = 0;
extern int cFF_Price = 0;
extern double cFF_Level = 0.06;
int gi_688;
int gi_692;
int g_hist_total_696 = 0;
double gd_700 = 0.0;
bool gi_708 = FALSE;
int g_datetime_712;
int g_datetime_716 = 0;
int g_datetime_720 = 0;
int g_datetime_724 = 0;
int g_datetime_728 = 0;
int g_datetime_732 = 0;
int g_datetime_736 = 0;
int g_datetime_740 = 0;
int g_datetime_744 = 0;
int g_datetime_748 = 0;
int g_datetime_752 = 0;
int g_datetime_756 = 0;
int g_datetime_760 = 0;
int g_datetime_764 = 0;
int g_datetime_768 = 0;

int init() {
   if (TS_ON && StopLoss == 0) Alert("  TS_ON    StopLoss");
   if (TP_ON && StopLoss == 0) Alert("  TP_ON    TakeProfit");
   g_hist_total_696 = 0;
   gd_700 = 0;
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   bool li_4;
   double l_icustom_8;
   double l_icustom_16;
   int li_24;
   int li_28;
   bool li_32;
   bool li_36;
   int li_40;
   int li_44;
   int li_48;
   if (!gi_708) {
      for (int l_pos_0 = 0; l_pos_0 < OrdersTotal(); l_pos_0++) {
         if (OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic_N) {
               if (OrderType() == OP_BUY) gi_688 = MathMax(gi_688, OrderOpenTime());
               if (OrderType() == OP_SELL) gi_692 = MathMax(gi_692, OrderOpenTime());
            }
         } else return (0);
      }
      for (l_pos_0 = 0; l_pos_0 < OrdersHistoryTotal(); l_pos_0++) {
         if (OrderSelect(l_pos_0, SELECT_BY_POS, MODE_HISTORY)) {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic_N) {
               if (OrderType() == OP_BUY) gi_688 = MathMax(gi_688, OrderOpenTime());
               if (OrderType() == OP_SELL) gi_692 = MathMax(gi_692, OrderOpenTime());
            }
         } else return (0);
      }
      if (gi_688 > gi_692) gi_692 = 0;
      if (gi_692 > gi_688) gi_688 = 0;
      if (TimeFrame == 0) TimeFrame = Period();
      gi_688 = 60 * TimeFrame * MathFloor(gi_688 / (60 * TimeFrame));
      gi_692 = 60 * TimeFrame * MathFloor(gi_692 / (60 * TimeFrame));
      gi_708 = TRUE;
   }
   if (UseKeepingRest) {
      if (IncreaseKeepingRest)
         if (!CountKeepingRestAdd()) Print("    ");
   }
   if (g_datetime_712 != iTime(NULL, TimeFrame, 0)) {
      li_4 = FALSE;
      l_icustom_8 = iCustom(NULL, TimeFrame, "MACD_MACR_FF_TRADE_(i)", E_FastMAPeriod, E_FastMAMethod, E_FastMAPrice, E_SlowMAPeriod, E_SlowMAMethod, E_SlowMAPrice, E_Confirm, T_ID, T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, T_MAPeriod, T_MAMethod, T_MAPrice, T_Level_1_Check, T_Level_1_Value, T_Level_2_Check, T_Level_2_Value, T_ValFromSignal, BuyOnGreen, BuyOnChoc, BuyOnRed, BuyOnBlue, SellOnGreen, SellOnChoc, SellOnRed, SellOnBlue, ArrowNumFrom, ArrowNumTo, FF_On, FF_Period, FF_MAMethod, FF_Price, FF_Level, 0, 1);
      l_icustom_16 = iCustom(NULL, TimeFrame, "MACD_MACR_FF_TRADE_(i)", E_FastMAPeriod, E_FastMAMethod, E_FastMAPrice, E_SlowMAPeriod, E_SlowMAMethod, E_SlowMAPrice, E_Confirm, T_ID, T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, T_MAPeriod, T_MAMethod, T_MAPrice, T_Level_1_Check, T_Level_1_Value, T_Level_2_Check, T_Level_2_Value, T_ValFromSignal, BuyOnGreen, BuyOnChoc, BuyOnRed, BuyOnBlue, SellOnGreen, SellOnChoc, SellOnRed, SellOnBlue, ArrowNumFrom, ArrowNumTo, FF_On, FF_Period, FF_MAMethod, FF_Price, FF_Level, 1, 1);
      li_24 = l_icustom_8 != EMPTY_VALUE;
      li_28 = l_icustom_16 != EMPTY_VALUE;
      li_32 = FALSE;
      li_36 = FALSE;
      if (UseCloseSig) {
         l_icustom_8 = iCustom(NULL, TimeFrame, "MACD_MACR_FF_TRADE_(i)", cE_FastMAPeriod, cE_FastMAMethod, cE_FastMAPrice, cE_SlowMAPeriod, cE_SlowMAMethod, cE_SlowMAPrice, cE_Confirm, cT_ID, cT_FastMA_Period, cT_FastMA_Method, cT_FastMA_Price, cT_SlowMA_Period, cT_SlowMA_Method, cT_SlowMA_Price, cT_SignalMA_Period, cT_SignalMA_Method, cT_MAPeriod, cT_MAMethod, cT_MAPrice, cT_Level_1_Check, cT_Level_1_Value, cT_Level_2_Check, cT_Level_2_Value, cT_ValFromSignal, cBuyOnGreen, cBuyOnChoc, cBuyOnRed, cBuyOnBlue, cSellOnGreen, cSellOnChoc, cSellOnRed, cSellOnBlue, cArrowNumFrom, cArrowNumTo, cFF_On, cFF_Period, cFF_MAMethod, cFF_Price, cFF_Level, 0, 1);
         l_icustom_16 = iCustom(NULL, TimeFrame, "MACD_MACR_FF_TRADE_(i)", cE_FastMAPeriod, cE_FastMAMethod, cE_FastMAPrice, cE_SlowMAPeriod, cE_SlowMAMethod, cE_SlowMAPrice, cE_Confirm, cT_ID, cT_FastMA_Period, cT_FastMA_Method, cT_FastMA_Price, cT_SlowMA_Period, cT_SlowMA_Method, cT_SlowMA_Price, cT_SignalMA_Period, cT_SignalMA_Method, cT_MAPeriod, cT_MAMethod, cT_MAPrice, cT_Level_1_Check, cT_Level_1_Value, cT_Level_2_Check, cT_Level_2_Value, cT_ValFromSignal, cBuyOnGreen, cBuyOnChoc, cBuyOnRed, cBuyOnBlue, cSellOnGreen, cSellOnChoc, cSellOnRed, cSellOnBlue, cArrowNumFrom, cArrowNumTo, cFF_On, cFF_Period, cFF_MAMethod, cFF_Price, cFF_Level, 1, 1);
         li_36 = l_icustom_8 != EMPTY_VALUE;
         li_32 = l_icustom_16 != EMPTY_VALUE;
         if (fOrderCloseMarket(li_32, li_36) != 0) li_4 = TRUE;
      }
      if (li_24 || li_28) {
         if (CloseOnRev)
            if (fOrderCloseMarket(li_28, li_24) != 0) li_4 = TRUE;
         li_48 = fMarketOrdersTotal(li_40, li_44);
         if (li_48 == -1) return (0);
         if (li_48 < MaxCount || MaxCount == -1) {
            if (li_24 && !li_32) {
               if (li_40 < MaxBuyCount || MaxBuyCount == -1) {
                  if (gi_688 != iTime(NULL, TimeFrame, 0))
                     if (fOrderOpenBuy() <= 0) li_4 = TRUE;
               }
            }
            if (li_28 && !li_36) {
               if (li_44 < MaxSellCount || MaxSellCount == -1) {
                  if (gi_692 != iTime(NULL, TimeFrame, 0))
                     if (fOrderOpenSell() <= 0) li_4 = TRUE;
               }
            }
         }
      }
      if (!li_4) g_datetime_712 = iTime(NULL, TimeFrame, 0);
   }
   if (UseCloseNoProfit) CloseNoProfit();
   if (TP_ON || TS_ON) TS();
   if (TrailingStop_Use) fTrailingWithStart();
   if (LBreakEven_Use) fBreakEvenToLevel();
   if (TrailingProf_Use) fTrailingProfWithStart();
   if (PBreakEven_Use) fProfBreakEvenToLevel();
   return (0);
}

void CloseNoProfit() {
   for (int l_pos_0 = 0; l_pos_0 < OrdersTotal(); l_pos_0++) {
      if (OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() == Magic_N) {
               if (iBarShift(NULL, TimeFrame, OrderOpenTime(), FALSE) > ExpireBars) {
                  if (OrderType() == OP_BUY)
                     if (ND(Bid - OrderOpenPrice()) >= ND(Point * MinProfitLevel)) OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, CLR_NONE);
                  if (OrderType() == OP_SELL)
                     if (ND(OrderOpenPrice() - Ask) >= ND(Point * MinProfitLevel)) OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, CLR_NONE);
               }
            }
         }
      }
   }
}

void TS() {
   double ld_0;
   double ld_8;
   double l_price_16;
   double l_price_24;
   for (int l_pos_32 = 0; l_pos_32 < OrdersTotal(); l_pos_32++) {
      if (OrderSelect(l_pos_32, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() == Magic_N) {
               if (OrderType() == OP_BUY) {
                  l_price_16 = ND(OrderStopLoss());
                  l_price_24 = ND(OrderTakeProfit());
                  if (TS_ON) {
                     ld_0 = ND(OrderOpenPrice() - Point * StopLoss + TS_SLStep_K * (Point * TSTP_PriceStep) * MathFloor((Ask - OrderOpenPrice()) / (Point * TSTP_PriceStep)));
                     if (ld_0 > ND(OrderStopLoss())) {
                        if (!TS_UseStartInProfit || ND(ld_0 - OrderOpenPrice()) >= ND(Point * TS_StartInProfit))
                           if (ld_0 <= ND(Bid - Point * (MarketInfo(Symbol(), MODE_STOPLEVEL) + 1.0))) l_price_16 = ld_0;
                     }
                  }
                  if (TP_ON) {
                     ld_8 = ND(OrderOpenPrice() + Point * TakeProfit + Point * TSTP_PriceStep * MathFloor((Ask - OrderOpenPrice()) / (Point * TSTP_PriceStep)));
                     if (ld_8 > ND(OrderTakeProfit()))
                        if (ld_8 >= ND(Ask + Point * (MarketInfo(Symbol(), MODE_STOPLEVEL) + 1.0))) l_price_24 = ld_8;
                  }
                  if (ND(l_price_16) != ND(OrderStopLoss()) || ND(l_price_24) != ND(OrderTakeProfit()))
                     if (ND(l_price_24 - l_price_16) >= ND(Point * TSTP_Minimal)) OrderModify(OrderTicket(), OrderOpenPrice(), l_price_16, l_price_24, 0, CLR_NONE);
               }
               if (OrderType() == OP_SELL) {
                  l_price_16 = ND(OrderStopLoss());
                  l_price_24 = ND(OrderTakeProfit());
                  if (TS_ON) {
                     ld_0 = ND(OrderOpenPrice() + Point * StopLoss - TS_SLStep_K * (Point * TSTP_PriceStep) * MathFloor((OrderOpenPrice() - Bid) / (Point * TSTP_PriceStep)));
                     if (ld_0 < ND(OrderStopLoss())) {
                        if (!TS_UseStartInProfit || ND(OrderOpenPrice() - ld_0) >= ND(Point * TS_StartInProfit))
                           if (ld_0 >= ND(Ask + Point * (MarketInfo(Symbol(), MODE_STOPLEVEL) + 1.0))) l_price_16 = ld_0;
                     }
                  }
                  if (TP_ON) {
                     ld_8 = ND(OrderOpenPrice() - Point * TakeProfit - Point * TSTP_PriceStep * MathFloor((OrderOpenPrice() - Bid) / (Point * TSTP_PriceStep)));
                     if (ld_8 < ND(OrderTakeProfit()))
                        if (ld_8 <= ND(Bid - Point * (MarketInfo(Symbol(), MODE_STOPLEVEL) + 1.0))) l_price_24 = ld_8;
                  }
                  if (ND(l_price_16) != ND(OrderStopLoss()) || ND(l_price_24) != ND(OrderTakeProfit()))
                     if (ND(l_price_16 - l_price_24) >= ND(Point * TSTP_Minimal)) OrderModify(OrderTicket(), OrderOpenPrice(), l_price_16, l_price_24, 0, CLR_NONE);
               }
            }
         }
      }
   }
}

int fOrderOpenBuy() {
   double l_price_8;
   double l_price_16;
   int l_ticket_24;
   RefreshRates();
   double l_lots_0 = fGetLotsSimple(OP_BUY);
   if (l_lots_0 > 0.0) {
      if (!IsTradeContextBusy()) {
         l_price_8 = ND(Ask - Point * StopLoss);
         if (StopLoss == 0) l_price_8 = 0;
         l_price_16 = ND(Ask + Point * TakeProfit);
         if (TakeProfit == 0) l_price_16 = 0;
         l_ticket_24 = OrderSend(Symbol(), OP_BUY, l_lots_0, ND(Ask), Slippage, l_price_8, l_price_16, 0, Magic_N, 0, CLR_NONE);
         if (l_ticket_24 > 0) {
            gi_688 = iTime(NULL, TimeFrame, 0);
            gi_692 = 0;
            return (l_ticket_24);
         }
         Print("Error open BUY. " + fMyErDesc(GetLastError()));
         return (-1);
      }
      if (g_datetime_716 != iTime(NULL, TimeFrame, 0)) {
         g_datetime_716 = iTime(NULL, TimeFrame, 0);
         Print("Need open buy. Trade Context Busy");
      }
      return (-2);
   }
   if (g_datetime_720 != iTime(NULL, TimeFrame, 0)) {
      g_datetime_720 = iTime(NULL, TimeFrame, 0);
      if (l_lots_0 == -1.0) Print("Need open buy. No money");
      if (l_lots_0 == -2.0) Print("Need open buy. Wrong lots size");
   }
   return (-3);
}

int fOrderOpenSell() {
   double l_price_8;
   double l_price_16;
   int l_ticket_24;
   RefreshRates();
   double l_lots_0 = fGetLotsSimple(OP_SELL);
   if (l_lots_0 > 0.0) {
      if (!IsTradeContextBusy()) {
         l_price_8 = ND(Bid + Point * StopLoss);
         if (StopLoss == 0) l_price_8 = 0;
         l_price_16 = ND(Bid - Point * TakeProfit);
         if (TakeProfit == 0) l_price_16 = 0;
         l_ticket_24 = OrderSend(Symbol(), OP_SELL, l_lots_0, ND(Bid), Slippage, l_price_8, l_price_16, 0, Magic_N, 0, CLR_NONE);
         if (l_ticket_24 > 0) {
            gi_692 = iTime(NULL, TimeFrame, 0);
            gi_688 = 0;
            return (l_ticket_24);
         }
         Print("Error open SELL. " + fMyErDesc(GetLastError()));
         return (-1);
      }
      if (g_datetime_724 != iTime(NULL, TimeFrame, 0)) {
         g_datetime_724 = iTime(NULL, TimeFrame, 0);
         Print("Need open sell. Trade Context Busy");
      }
      return (-2);
   }
   if (g_datetime_728 != iTime(NULL, TimeFrame, 0)) {
      g_datetime_728 = iTime(NULL, TimeFrame, 0);
      if (l_lots_0 == -1.0) Print("Need open sell. No money");
      if (l_lots_0 == -2.0) Print("Need open sell. Wrong lots size");
   }
   return (-3);
}

int fOrderCloseMarket(bool ai_0 = TRUE, bool ai_4 = TRUE) {
   int li_ret_8 = 0;
   for (int l_pos_12 = OrdersTotal() - 1; l_pos_12 >= 0; l_pos_12--) {
      if (OrderSelect(l_pos_12, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic_N) {
            if (OrderType() == OP_BUY && ai_0) {
               RefreshRates();
               if (!IsTradeContextBusy()) {
                  if (!OrderClose(OrderTicket(), OrderLots(), ND(Bid), Slippage, CLR_NONE)) {
                     Print("Error close BUY " + OrderTicket() + " " + fMyErDesc(GetLastError()));
                     li_ret_8 = -1;
                  }
               } else {
                  if (g_datetime_732 != iTime(NULL, TimeFrame, 0)) {
                     g_datetime_732 = iTime(NULL, TimeFrame, 0);
                     Print("Need close BUY " + OrderTicket() + ". Trade Context Busy");
                  }
                  return (-2);
               }
            }
            if (OrderType() == OP_SELL && ai_4) {
               RefreshRates();
               if (!IsTradeContextBusy()) {
                  if (!OrderClose(OrderTicket(), OrderLots(), ND(Ask), Slippage, CLR_NONE)) {
                     Print("Error close SELL " + OrderTicket() + " " + fMyErDesc(GetLastError()));
                     li_ret_8 = -1;
                  }
               } else {
                  if (g_datetime_736 != iTime(NULL, TimeFrame, 0)) {
                     g_datetime_736 = iTime(NULL, TimeFrame, 0);
                     Print("Need close SELL " + OrderTicket() + ". Trade Context Busy");
                  }
                  return (-2);
               }
            }
         }
      }
   }
   return (li_ret_8);
}

int fMarketOrdersTotal(int &a_count_0, int &a_count_4) {
   a_count_0 = 0;
   a_count_4 = 0;
   for (int l_pos_8 = 0; l_pos_8 < OrdersTotal(); l_pos_8++) {
      if (OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic_N) {
            switch (OrderType()) {
            case OP_BUY:
               a_count_0++;
               break;
            case OP_SELL:
               a_count_4++;
            }
         }
      } else return (-1);
   }
   return (a_count_0 + a_count_4);
}

double ND(double ad_0) {
   return (NormalizeDouble(ad_0, Digits));
}

double fGetLotsSimple(int a_cmd_0) {
   double l_free_magrin_12;
   double ld_24;
   double l_minlot_32;
   double l_lotstep_40;
   double ld_ret_4 = Lots;
   if (!(FixedLots && !UseKeepingRest)) {
      l_free_magrin_12 = AccountFreeMargin();
      switch (MeansType) {
      case 1:
         l_free_magrin_12 = AccountBalance();
         break;
      case 2:
         l_free_magrin_12 = AccountEquity();
      }
      if (!FixedLots) {
         ld_24 = Risk * l_free_magrin_12;
         ld_ret_4 = ld_24 / 1000.0;
         l_minlot_32 = MarketInfo(Symbol(), MODE_MINLOT);
         l_lotstep_40 = MarketInfo(Symbol(), MODE_LOTSTEP);
         ld_ret_4 = NormalizeDouble(l_minlot_32 + l_lotstep_40 * MathFloor((ld_ret_4 - l_minlot_32) / l_lotstep_40), 2);
      } else {
         ld_24 = 1000.0 * Lots;
         ld_ret_4 = Lots;
      }
      if (UseKeepingRest) {
         if (l_free_magrin_12 - ld_24 < KeepingRest + gd_700) {
            ld_24 = l_free_magrin_12 - (KeepingRest + gd_700);
            ld_ret_4 = ld_24 / 1000.0;
            l_minlot_32 = MarketInfo(Symbol(), MODE_MINLOT);
            l_lotstep_40 = MarketInfo(Symbol(), MODE_LOTSTEP);
            ld_ret_4 = NormalizeDouble(l_minlot_32 + l_lotstep_40 * MathFloor((ld_ret_4 - l_minlot_32) / l_lotstep_40), 2);
         }
      }
   }
   if (AccountFreeMarginCheck(Symbol(), a_cmd_0, ld_ret_4) <= 0.0) return (-1);
   if (GetLastError() == 134/* NOT_ENOUGH_MONEY */) return (-2);
   return (ld_ret_4);
}

bool CountKeepingRestAdd() {
   double ld_0;
   if (OrdersHistoryTotal() > g_hist_total_696) {
      ld_0 = gd_700;
      for (int l_pos_8 = OrdersHistoryTotal() - 1; l_pos_8 >= g_hist_total_696; l_pos_8--) {
         if (OrderSelect(l_pos_8, SELECT_BY_POS, MODE_HISTORY)) {
            if (OrderSymbol() == Symbol()) {
               if (OrderMagicNumber() == Magic_N) {
                  if (OrderOpenTime() >= OrdersFrom) {
                     if (OrderType() == OP_BUY || OrderType() == OP_SELL)
                        if (OrderProfit() > 0.0) gd_700 += OrderProfit() * (IncreasePercents / 100.0);
                  }
               }
            }
         } else return (FALSE);
      }
      g_hist_total_696 = OrdersHistoryTotal();
      if (ld_0 != gd_700) Print("    : " + DS2(KeepingRest + gd_700) + "$");
   }
   return (TRUE);
}

string DS2(double ad_0) {
   return (DoubleToStr(ad_0, 2));
}

string fMyErDesc(int ai_0) {
   string ls_4 = "Err Num: " + ai_0 + " - ";
   switch (ai_0) {
   case 0:
      return (ls_4 + "NO ERROR");
   case 1:
      return (ls_4 + "NO RESULT");
   case 2:
      return (ls_4 + "COMMON ERROR");
   case 3:
      return (ls_4 + "INVALID TRADE PARAMETERS");
   case 4:
      return (ls_4 + "SERVER BUSY");
   case 5:
      return (ls_4 + "OLD VERSION");
   case 6:
      return (ls_4 + "NO CONNECTION");
   case 7:
      return (ls_4 + "NOT ENOUGH RIGHTS");
   case 8:
      return (ls_4 + "TOO FREQUENT REQUESTS");
   case 9:
      return (ls_4 + "MALFUNCTIONAL TRADE");
   case 64:
      return (ls_4 + "ACCOUNT DISABLED");
   case 65:
      return (ls_4 + "INVALID ACCOUNT");
   case 128:
      return (ls_4 + "TRADE TIMEOUT");
   case 129:
      return (ls_4 + "INVALID PRICE");
   case 130:
      return (ls_4 + "INVALID STOPS");
   case 131:
      return (ls_4 + "INVALID TRADE VOLUME");
   case 132:
      return (ls_4 + "MARKET CLOSED");
   case 133:
      return (ls_4 + "TRADE DISABLED");
   case 134:
      return (ls_4 + "NOT ENOUGH MONEY");
   case 135:
      return (ls_4 + "PRICE CHANGED");
   case 136:
      return (ls_4 + "OFF QUOTES");
   case 137:
      return (ls_4 + "BROKER BUSY");
   case 138:
      return (ls_4 + "REQUOTE");
   case 139:
      return (ls_4 + "ORDER LOCKED");
   case 140:
      return (ls_4 + "LONG POSITIONS ONLY ALLOWED");
   case 141:
      return (ls_4 + "TOO MANY REQUESTS");
   case 145:
      return (ls_4 + "TRADE MODIFY DENIED");
   case 146:
      return (ls_4 + "TRADE CONTEXT BUSY");
   case 147:
      return (ls_4 + "TRADE EXPIRATION DENIED");
   case 148:
      return (ls_4 + "TRADE TOO MANY ORDERS");
   case 4000:
      return (ls_4 + "NO MQLERROR");
   case 4001:
      return (ls_4 + "WRONG FUNCTION POINTER");
   case 4002:
      return (ls_4 + "ARRAY INDEX OUT OF RANGE");
   case 4003:
      return (ls_4 + "NO MEMORY FOR FUNCTION CALL STACK");
   case 4004:
      return (ls_4 + "RECURSIVE STACK OVERFLOW");
   case 4005:
      return (ls_4 + "NOT ENOUGH STACK FOR PARAMETER");
   case 4006:
      return (ls_4 + "NO MEMORY FOR PARAMETER STRING");
   case 4007:
      return (ls_4 + "NO MEMORY FOR TEMP STRING");
   case 4008:
      return (ls_4 + "NOT INITIALIZED STRING");
   case 4009:
      return (ls_4 + "NOT INITIALIZED ARRAYSTRING");
   case 4010:
      return (ls_4 + "NO MEMORY FOR ARRAYSTRING");
   case 4011:
      return (ls_4 + "TOO LONG STRING");
   case 4012:
      return (ls_4 + "REMAINDER FROM ZERO DIVIDE");
   case 4013:
      return (ls_4 + "ZERO DIVIDE");
   case 4014:
      return (ls_4 + "UNKNOWN COMMAND");
   case 4015:
      return (ls_4 + "WRONG JUMP");
   case 4016:
      return (ls_4 + "NOT INITIALIZED ARRAY");
   case 4017:
      return (ls_4 + "DLL CALLS NOT ALLOWED");
   case 4018:
      return (ls_4 + "CANNOT LOAD LIBRARY");
   case 4019:
      return (ls_4 + "CANNOT CALL FUNCTION");
   case 4020:
      return (ls_4 + "EXTERNAL EXPERT CALLS NOT ALLOWED");
   case 4021:
      return (ls_4 + "NOT ENOUGH MEMORY FOR RETURNED STRING");
   case 4022:
      return (ls_4 + "SYSTEM BUSY");
   case 4050:
      return (ls_4 + "INVALID FUNCTION PARAMETERS COUNT");
   case 4051:
      return (ls_4 + "INVALID FUNCTION PARAMETER VALUE");
   case 4052:
      return (ls_4 + "STRING FUNCTION INTERNAL ERROR");
   case 4053:
      return (ls_4 + "SOME ARRAY ERROR");
   case 4054:
      return (ls_4 + "INCORRECT SERIES ARRAY USING");
   case 4055:
      return (ls_4 + "CUSTOM INDICATOR ERROR");
   case 4056:
      return (ls_4 + "INCOMPATIBLE ARRAYS");
   case 4057:
      return (ls_4 + "GLOBAL VARIABLES PROCESSING ERROR");
   case 4058:
      return (ls_4 + "GLOBAL VARIABLE NOT FOUND");
   case 4059:
      return (ls_4 + "FUNCTION NOT ALLOWED IN TESTING MODE");
   case 4060:
      return (ls_4 + "FUNCTION NOT CONFIRMED");
   case 4061:
      return (ls_4 + "SEND MAIL ERROR");
   case 4062:
      return (ls_4 + "STRING PARAMETER EXPECTED");
   case 4063:
      return (ls_4 + "INTEGER PARAMETER EXPECTED");
   case 4064:
      return (ls_4 + "DOUBLE PARAMETER EXPECTED");
   case 4065:
      return (ls_4 + "ARRAY AS PARAMETER EXPECTED");
   case 4066:
      return (ls_4 + "HISTORY WILL UPDATED");
   case 4067:
      return (ls_4 + "TRADE ERROR");
   case 4099:
      return (ls_4 + "END OF FILE");
   case 4100:
      return (ls_4 + "SOME FILE ERROR");
   case 4101:
      return (ls_4 + "WRONG FILE NAME");
   case 4102:
      return (ls_4 + "TOO MANY OPENED FILES");
   case 4103:
      return (ls_4 + "CANNOT OPEN FILE");
   case 4104:
      return (ls_4 + "INCOMPATIBLE ACCESS TO FILE");
   case 4105:
      return (ls_4 + "NO ORDER SELECTED");
   case 4106:
      return (ls_4 + "UNKNOWN SYMBOL");
   case 4107:
      return (ls_4 + "INVALID PRICE PARAM");
   case 4108:
      return (ls_4 + "INVALID TICKET");
   case 4109:
      return (ls_4 + "TRADE NOT ALLOWED");
   case 4110:
      return (ls_4 + "LONGS  NOT ALLOWED");
   case 4111:
      return (ls_4 + "SHORTS NOT ALLOWED");
   case 4200:
      return (ls_4 + "OBJECT ALREADY EXISTS");
   case 4201:
      return (ls_4 + "UNKNOWN OBJECT PROPERTY");
   case 4202:
      return (ls_4 + "OBJECT DOES NOT EXIST");
   case 4203:
      return (ls_4 + "UNKNOWN OBJECT TYPE");
   case 4204:
      return (ls_4 + "NO OBJECT NAME");
   case 4205:
      return (ls_4 + "OBJECT COORDINATES ERROR");
   case 4206:
      return (ls_4 + "NO SPECIFIED SUBWINDOW");
   case 4207:
      return (ls_4 + "SOME OBJECT ERROR");
   }
   return (ls_4 + "WRONG ERR NUM");
}

void fTrailingWithStart() {
   double l_price_0;
   for (int l_pos_8 = 0; l_pos_8 < OrdersTotal(); l_pos_8++) {
      if (OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic_N) {
            if (OrderType() == OP_BUY) {
               RefreshRates();
               if (ND(Bid - OrderOpenPrice()) >= ND(Point * TrailingStopStart)) {
                  l_price_0 = ND(Bid - Point * TrailingStop);
                  if (ND(OrderStopLoss()) < l_price_0) {
                     if (!IsTradeContextBusy()) {
                        if (!OrderModify(OrderTicket(), OrderOpenPrice(), l_price_0, OrderTakeProfit(), 0, CLR_NONE)) Print("Error trailingstop BUY " + OrderTicket() + " " + fMyErDesc(GetLastError()));
                     } else {
                        if (g_datetime_740 + 15 < TimeCurrent()) {
                           g_datetime_740 = TimeCurrent();
                           Print("Need trailingstop BUY " + OrderTicket() + ". Trade Context Busy");
                        }
                     }
                  }
               }
            }
            if (OrderType() == OP_SELL) {
               RefreshRates();
               if (ND(OrderOpenPrice() - Ask) >= ND(Point * TrailingStopStart)) {
                  l_price_0 = ND(Ask + Point * TrailingStop);
                  if (!IsTradeContextBusy()) {
                     if (ND(OrderStopLoss()) > l_price_0 || ND(OrderStopLoss()) == 0.0)
                        if (!OrderModify(OrderTicket(), OrderOpenPrice(), l_price_0, OrderTakeProfit(), 0, CLR_NONE)) Print("Error trailingstop SELL " + OrderTicket() + " " + fMyErDesc(GetLastError()));
                  } else {
                     if (g_datetime_744 + 15 < TimeCurrent()) {
                        g_datetime_744 = TimeCurrent();
                        Print("Need trailingstop SELL " + OrderTicket() + ". Trade Context Busy");
                     }
                  }
               }
            }
         }
      }
   }
}

void fBreakEvenToLevel() {
   double l_price_0;
   for (int l_pos_8 = 0; l_pos_8 < OrdersTotal(); l_pos_8++) {
      if (OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic_N) {
            if (OrderType() == OP_BUY) {
               RefreshRates();
               if (ND(Bid - OrderOpenPrice()) >= ND(Point * LBreakEvenStart)) {
                  l_price_0 = ND(OrderOpenPrice() + Point * (LBreakEvenStart - LBreakEvenLevel));
                  if (ND(OrderStopLoss()) < l_price_0) {
                     if (!IsTradeContextBusy()) {
                        if (ND(OrderStopLoss()) < l_price_0)
                           if (!OrderModify(OrderTicket(), OrderOpenPrice(), l_price_0, OrderTakeProfit(), 0, CLR_NONE)) Print("Error breakeven BUY " + OrderTicket() + " " + fMyErDesc(GetLastError()));
                     } else {
                        if (g_datetime_748 + 15 < TimeCurrent()) {
                           g_datetime_748 = TimeCurrent();
                           Print("Need breakeven BUY " + OrderTicket() + ". Trade Context Busy");
                        }
                     }
                  }
               }
            }
            if (OrderType() == OP_SELL) {
               RefreshRates();
               if (ND(OrderOpenPrice() - Ask) >= ND(Point * LBreakEvenStart)) {
                  l_price_0 = ND(OrderOpenPrice() - Point * (LBreakEvenStart - LBreakEvenLevel));
                  if (ND(OrderStopLoss()) > l_price_0 || ND(OrderStopLoss()) == 0.0) {
                     if (!IsTradeContextBusy()) {
                        if (ND(OrderStopLoss()) > l_price_0 || ND(OrderStopLoss()) == 0.0)
                           if (!OrderModify(OrderTicket(), OrderOpenPrice(), l_price_0, OrderTakeProfit(), 0, CLR_NONE)) Print("Error breakeven SELL " + OrderTicket() + " " + fMyErDesc(GetLastError()));
                     } else {
                        if (g_datetime_752 + 15 < TimeCurrent()) {
                           g_datetime_752 = TimeCurrent();
                           Print("Need breakeven SELL " + OrderTicket() + ". Trade Context Busy");
                        }
                     }
                  }
               }
            }
         }
      }
   }
}

void fTrailingProfWithStart() {
   double l_price_0;
   for (int l_pos_8 = 0; l_pos_8 < OrdersTotal(); l_pos_8++) {
      if (OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic_N) {
            if (OrderType() == OP_BUY) {
               RefreshRates();
               if (ND(Bid - OrderOpenPrice()) <= ND((-Point) * TrailingProfStart)) {
                  l_price_0 = ND(Bid + Point * TrailingProf);
                  if (ND(OrderTakeProfit()) > l_price_0 || ND(OrderTakeProfit()) == 0.0) {
                     if (!IsTradeContextBusy()) {
                        if (!OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), l_price_0, 0, CLR_NONE)) Print("Error trailingstop BUY " + OrderTicket() + " " + fMyErDesc(GetLastError()));
                     } else {
                        if (g_datetime_756 + 15 < TimeCurrent()) {
                           g_datetime_756 = TimeCurrent();
                           Print("Need trailingprofit BUY " + OrderTicket() + ". Trade Context Busy");
                        }
                     }
                  }
               }
            }
            if (OrderType() == OP_SELL) {
               RefreshRates();
               if (ND(OrderOpenPrice() - Ask) <= ND((-Point) * TrailingProfStart)) {
                  l_price_0 = ND(Ask - Point * TrailingProf);
                  if (!IsTradeContextBusy()) {
                     if (ND(OrderTakeProfit()) < l_price_0)
                        if (!OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), l_price_0, 0, CLR_NONE)) Print("Error trailingprofit SELL " + OrderTicket() + " " + fMyErDesc(GetLastError()));
                  } else {
                     if (g_datetime_760 + 15 < TimeCurrent()) {
                        g_datetime_760 = TimeCurrent();
                        Print("Need trailingprofit SELL " + OrderTicket() + ". Trade Context Busy");
                     }
                  }
               }
            }
         }
      }
   }
}

void fProfBreakEvenToLevel() {
   double l_price_0;
   for (int l_pos_8 = 0; l_pos_8 < OrdersTotal(); l_pos_8++) {
      if (OrderSelect(l_pos_8, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic_N) {
            if (OrderType() == OP_BUY) {
               RefreshRates();
               if (ND(Bid - OrderOpenPrice()) <= ND((-Point) * PBreakEvenStart)) {
                  l_price_0 = ND(OrderOpenPrice() - Point * (PBreakEvenStart - PBreakEvenLevel));
                  if (ND(OrderTakeProfit()) > l_price_0 || ND(OrderTakeProfit()) == 0.0) {
                     if (!IsTradeContextBusy()) {
                        if (ND(OrderTakeProfit()) > l_price_0 || ND(OrderTakeProfit()) == 0.0)
                           if (!OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), l_price_0, 0, CLR_NONE)) Print("Error breakeven BUY " + OrderTicket() + " " + fMyErDesc(GetLastError()));
                     } else {
                        if (g_datetime_764 + 15 < TimeCurrent()) {
                           g_datetime_764 = TimeCurrent();
                           Print("Need breakeven BUY " + OrderTicket() + ". Trade Context Busy");
                        }
                     }
                  }
               }
            }
            if (OrderType() == OP_SELL) {
               RefreshRates();
               if (ND(OrderOpenPrice() - Ask) <= ND(Point * PBreakEvenStart)) {
                  l_price_0 = ND(OrderOpenPrice() + Point * (PBreakEvenStart - PBreakEvenLevel));
                  if (ND(OrderTakeProfit()) < l_price_0) {
                     if (!IsTradeContextBusy()) {
                        if (ND(OrderTakeProfit()) < l_price_0)
                           if (!OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss(), l_price_0, 0, CLR_NONE)) Print("Error profitbreakeven SELL " + OrderTicket() + " " + fMyErDesc(GetLastError()));
                     } else {
                        if (g_datetime_768 + 15 < TimeCurrent()) {
                           g_datetime_768 = TimeCurrent();
                           Print("Need profitbreakeven SELL " + OrderTicket() + ". Trade Context Busy");
                        }
                     }
                  }
               }
            }
         }
      }
   }
}
