#property copyright "Copyright  2007, YURAZ"
#property link      "yzh@mail.ru"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Green
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Red
#property indicator_color4 BurlyWood
#property indicator_color5 CLR_NONE
#property indicator_color6 Chocolate

extern int FastMA_Period = 12;
int gi_80 = 0;
extern int FastMA_Method = 1;
extern int FastMA_Price = 0;
extern int SlowMA_Period = 26;
int gi_96 = 0;
extern int SlowMA_Method = 1;
extern int SlowMA_Price = 0;
extern int SignalMA_Period = 9;
int gi_112 = 0;
extern int SignalMA_Method = 0;
extern int MAPeriod = 13;
extern int MAMethod = 1;
extern int MAPrice = 0;
int g_timeframe_132 = 0;
int g_timeframe_136 = 0;
double g_ibuf_140[];
double g_ibuf_144[];
double g_ibuf_148[];
double g_ibuf_152[];
double g_ibuf_156[];
double g_ibuf_160[];
int gi_164;
int gi_168;

int init() {
   if (FastMA_Price > PRICE_WEIGHTED || FastMA_Price < PRICE_CLOSE) FastMA_Price = 0;
   if (FastMA_Method > MODE_LWMA || FastMA_Method < MODE_SMA) FastMA_Method = 1;
   if (FastMA_Period <= 0) FastMA_Period = 12;
   if (SlowMA_Price > PRICE_WEIGHTED || SlowMA_Price < PRICE_CLOSE) SlowMA_Price = 0;
   if (SlowMA_Method > MODE_LWMA || SlowMA_Method < MODE_SMA) SlowMA_Method = 1;
   if (SlowMA_Period <= 0) SlowMA_Period = 26;
   if (SignalMA_Method > MODE_LWMA || SignalMA_Method < MODE_SMA) SignalMA_Method = 0;
   if (SignalMA_Period <= 0) SignalMA_Period = 9;
   if (gi_80 < 0) gi_80 = 0;
   if (gi_96 < 0) gi_96 = 0;
   if (gi_80 >= gi_96) gi_164 = gi_80;
   else gi_164 = gi_96;
   if (FastMA_Period >= SlowMA_Period) {
      FastMA_Period = 12;
      SlowMA_Period = 26;
   }
   if (SignalMA_Period >= SlowMA_Period) gi_168 = SignalMA_Period;
   else gi_168 = SlowMA_Period;
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexDrawBegin(0, gi_168 + gi_164 + SignalMA_Period << 2);
   SetIndexBuffer(0, g_ibuf_148);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexDrawBegin(1, gi_168 + gi_164 + SignalMA_Period << 2);
   SetIndexBuffer(1, g_ibuf_152);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexDrawBegin(2, gi_168 + gi_164 + SignalMA_Period << 2);
   SetIndexBuffer(2, g_ibuf_156);
   SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexDrawBegin(3, gi_168 + gi_164 + SignalMA_Period << 2);
   SetIndexBuffer(3, g_ibuf_160);
   SetIndexStyle(4, DRAW_HISTOGRAM);
   SetIndexDrawBegin(4, gi_168 + gi_164 + SignalMA_Period << 2);
   SetIndexBuffer(4, g_ibuf_140);
   SetIndexStyle(5, DRAW_LINE);
   SetIndexDrawBegin(5, gi_168 + gi_164 + SignalMA_Period << 2);
   SetIndexBuffer(5, g_ibuf_144);
   SetIndexShift(5, gi_112);
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS) + 1.0);
   IndicatorShortName("MACDCOLOR MS (" + FastMA_Period + "," + SlowMA_Period + "," + SignalMA_Period + "," + MAPeriod + ")");
   SetIndexLabel(0, "Buy Signal");
   SetIndexLabel(1, "MA Dn, Main Up");
   SetIndexLabel(2, "Sell Signal");
   SetIndexLabel(3, "MA Up, Main Dn");
   SetIndexLabel(4, NULL);
   SetIndexLabel(5, "Signal");
   return (0);
}

int start() {
   double ld_4;
   double ld_12;
   double l_ima_20;
   double l_ima_28;
   int li_36 = IndicatorCounted();
   if (li_36 < 0) return (-1);
   if (li_36 > 0) li_36--;
   int li_0 = Bars - li_36;
   for (int li_40 = 0; li_40 < li_0; li_40++) g_ibuf_140[li_40] = iMA(Symbol(), g_timeframe_132, FastMA_Period, gi_80, FastMA_Method, FastMA_Price, li_40) - iMA(Symbol(), g_timeframe_136, SlowMA_Period, gi_96, SlowMA_Method, SlowMA_Price, li_40);
   for (int li_44 = 0; li_44 <= li_0 - 1; li_44++) g_ibuf_144[li_44] = iMAOnArray(g_ibuf_140, Bars, SignalMA_Period, 0, SignalMA_Method, li_44);
   li_40 = 0;
   for (li_44 = 0; li_40 <= li_0 - 1; li_44++) {
      ld_12 = g_ibuf_140[li_40];
      ld_4 = g_ibuf_140[li_40 + 1];
      l_ima_28 = iMA(NULL, 0, MAPeriod, 0, MAMethod, MAPrice, li_40);
      l_ima_20 = iMA(NULL, 0, MAPeriod, 0, MAMethod, MAPrice, li_40 + 1);
      g_ibuf_148[li_40] = 0.0;
      g_ibuf_152[li_40] = 0.0;
      g_ibuf_156[li_40] = 0.0;
      g_ibuf_160[li_40] = 0.0;
      if (ld_12 > ld_4 && l_ima_28 > l_ima_20) {
         g_ibuf_148[li_40] = ld_12;
         g_ibuf_152[li_40] = 0.0;
         g_ibuf_156[li_40] = 0.0;
         g_ibuf_160[li_40] = 0.0;
      } else {
         if (ld_12 < ld_4 && l_ima_28 < l_ima_20) {
            g_ibuf_148[li_40] = 0.0;
            g_ibuf_152[li_40] = 0.0;
            g_ibuf_156[li_40] = ld_12;
            g_ibuf_160[li_40] = 0.0;
         } else {
            if (ld_12 > ld_4 && l_ima_28 < l_ima_20) {
               g_ibuf_148[li_40] = 0.0;
               g_ibuf_152[li_40] = ld_12;
               g_ibuf_156[li_40] = 0.0;
               g_ibuf_160[li_40] = 0.0;
            } else {
               if (ld_12 < ld_4 && l_ima_28 > l_ima_20) {
                  g_ibuf_148[li_40] = 0.0;
                  g_ibuf_152[li_40] = 0.0;
                  g_ibuf_156[li_40] = 0.0;
                  g_ibuf_160[li_40] = ld_12;
               }
            }
         }
      }
      li_40++;
   }
   return (0);
}
