#property copyright "*"
#property link      "*"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Red
#property indicator_color3 CLR_NONE

extern int E_FastMAPeriod = 5;
extern int E_FastMAMethod = 3;
extern int E_FastMAPrice = 0;
extern int E_SlowMAPeriod = 6;
extern int E_SlowMAMethod = 3;
extern int E_SlowMAPrice = 0;
extern bool E_Confirm = TRUE;
extern int T_ID = 1;
extern int T_FastMA_Period = 12;
extern int T_FastMA_Method = 1;
extern int T_FastMA_Price = 0;
extern int T_SlowMA_Period = 26;
extern int T_SlowMA_Method = 1;
extern int T_SlowMA_Price = 0;
extern int T_SignalMA_Period = 9;
extern int T_SignalMA_Method = 0;
extern int T_MAPeriod = 13;
extern int T_MAMethod = 1;
extern int T_MAPrice = 0;
extern bool T_Level_1_Check = FALSE;
extern double T_Level_1_Value = 0.0;
extern bool T_Level_2_Check = FALSE;
extern double T_Level_2_Value = 0.0;
extern bool T_ValFromSignal = FALSE;
extern bool BuyOnGreen = TRUE;
extern bool BuyOnChoc = TRUE;
extern bool BuyOnRed = FALSE;
extern bool BuyOnBlue = TRUE;
extern bool SellOnGreen = FALSE;
extern bool SellOnChoc = TRUE;
extern bool SellOnRed = TRUE;
extern bool SellOnBlue = TRUE;
extern int ArrowNumFrom = 1;
extern int ArrowNumTo = 0;
extern int FF_On = 1;
extern int FF_Period = 13;
extern int FF_MAMethod = 0;
extern int FF_Price = 0;
extern double FF_Level = 0.06;
double g_icustom_244;
double g_icustom_252;
double g_icustom_260;
double g_icustom_268;
double g_icustom_276;
double g_icustom_284;
double g_icustom_292;
double gd_300;
int gi_308;
int gi_312;
double g_ibuf_316[];
double g_ibuf_320[];
double g_ibuf_324[];
double g_ibuf_328[];
double g_ibuf_332[];

int init() {
   gi_312 = 4;
   if (T_ValFromSignal) gi_312 = 5;
   gd_300 = Point * PTA(Period());
   IndicatorBuffers(5);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, g_ibuf_316);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, g_ibuf_320);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, g_ibuf_332);
   SetIndexEmptyValue(2, 0.0);
   SetIndexBuffer(3, g_ibuf_324);
   SetIndexBuffer(4, g_ibuf_328);
   SetIndexLabel(0, "Buy");
   SetIndexLabel(1, "Sell");
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   bool li_8;
   bool li_12;
   double ld_20;
   double ld_28;
   int li_0 = Bars - IndicatorCounted();
   switch (T_ID) {
   case 1:
      for (gi_308 = li_0 - 1; gi_308 >= 0; gi_308--) {
         g_ibuf_324[gi_308] = EMPTY_VALUE;
         g_ibuf_328[gi_308] = EMPTY_VALUE;
         g_ibuf_332[gi_308] = g_ibuf_332[gi_308 + 1];
         g_icustom_260 = iCustom(NULL, 0, "MACD_ELDER_MT_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, 0, gi_308);
         g_icustom_268 = iCustom(NULL, 0, "MACD_ELDER_MT_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, 1, gi_308);
         g_icustom_252 = iCustom(NULL, 0, "MACD_ELDER_MT_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, 2, gi_308);
         g_icustom_276 = iCustom(NULL, 0, "MACD_ELDER_MT_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, 3, gi_308);
         g_icustom_244 = iCustom(NULL, 0, "MACD_ELDER_MT_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, gi_312, gi_308);
         g_icustom_284 = iCustom(NULL, 0, "EMA_CROSSOVER_SIGNAL_2_(i)", E_FastMAPeriod, E_FastMAMethod, E_FastMAPrice, E_SlowMAPeriod, E_SlowMAMethod, E_SlowMAPrice, E_Confirm, 0, gi_308);
         g_icustom_292 = iCustom(NULL, 0, "EMA_CROSSOVER_SIGNAL_2_(i)", E_FastMAPeriod, E_FastMAMethod, E_FastMAPrice, E_SlowMAPeriod, E_SlowMAMethod, E_SlowMAPrice, E_Confirm, 1, gi_308);
         li_8 = FALSE;
         li_12 = FALSE;
         switch (FF_On) {
         case 0:
            li_8 = TRUE;
            li_12 = TRUE;
            break;
         case 1:
            ld_20 = Volume[gi_308] * (iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308) - iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 1));
            ld_28 = (Volume[gi_308 + 1]) * (iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 1) - iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 2));
            if (ld_20 > FF_Level) li_8 = TRUE;
            if (ld_20 < -FF_Level) li_12 = TRUE;
            break;
         case 2:
            ld_20 = Volume[gi_308] * (iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308) - iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 1));
            ld_28 = (Volume[gi_308 + 1]) * (iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 1) - iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 2));
            if (ld_20 > FF_Level && ld_28 <= FF_Level) li_8 = TRUE;
            if (ld_20 < (-FF_Level) && ld_28 >= (-FF_Level)) li_12 = TRUE;
         }
         if (g_icustom_284 != EMPTY_VALUE && li_8) {
            if ((g_icustom_260 != 0.0 && BuyOnGreen) || (g_icustom_268 != 0.0 && BuyOnBlue) || (g_icustom_252 != 0.0 && BuyOnRed) || (g_icustom_276 != 0.0 && BuyOnChoc)) {
               if (g_icustom_244 > T_Level_1_Value || !T_Level_1_Check && g_icustom_244 < T_Level_2_Value || !T_Level_2_Check) {
                  g_ibuf_324[gi_308] = Low[gi_308] - gd_300;
                  if (g_ibuf_332[gi_308] <= 0.0) g_ibuf_332[gi_308] = 1;
                  else g_ibuf_332[gi_308]++;
               }
            }
         }
         if (g_icustom_292 != EMPTY_VALUE && li_12) {
            if ((g_icustom_260 != 0.0 && SellOnGreen) || (g_icustom_268 != 0.0 && SellOnBlue) || (g_icustom_252 != 0.0 && SellOnRed) || (g_icustom_276 != 0.0 && SellOnChoc)) {
               if (g_icustom_244 < (-T_Level_1_Value) || !T_Level_1_Check && g_icustom_244 > (-T_Level_2_Value) || !T_Level_2_Check) {
                  g_ibuf_328[gi_308] = High[gi_308] + gd_300;
                  if (g_ibuf_332[gi_308] >= 0.0) g_ibuf_332[gi_308] = -1;
                  else g_ibuf_332[gi_308]--;
               }
            }
         }
      }
      break;
   case 2:
      for (gi_308 = li_0 - 1; gi_308 >= 0; gi_308--) {
         g_ibuf_324[gi_308] = EMPTY_VALUE;
         g_ibuf_328[gi_308] = EMPTY_VALUE;
         g_ibuf_332[gi_308] = g_ibuf_332[gi_308 + 1];
         g_icustom_260 = iCustom(NULL, 0, "MACD_ELDER_MS_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, T_MAPeriod, T_MAMethod, T_MAPrice, 0, gi_308);
         g_icustom_268 = iCustom(NULL, 0, "MACD_ELDER_MS_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, T_MAPeriod, T_MAMethod, T_MAPrice, 1, gi_308);
         g_icustom_252 = iCustom(NULL, 0, "MACD_ELDER_MS_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, T_MAPeriod, T_MAMethod, T_MAPrice, 2, gi_308);
         g_icustom_276 = iCustom(NULL, 0, "MACD_ELDER_MS_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, T_MAPeriod, T_MAMethod, T_MAPrice, 3, gi_308);
         g_icustom_244 = iCustom(NULL, 0, "MACD_ELDER_MS_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, T_MAPeriod, T_MAMethod, T_MAPrice, gi_312, gi_308);
         g_icustom_284 = iCustom(NULL, 0, "EMA_CROSSOVER_SIGNAL_2_(i)", E_FastMAPeriod, E_FastMAMethod, E_FastMAPrice, E_SlowMAPeriod, E_SlowMAMethod, E_SlowMAPrice, E_Confirm, 0, gi_308);
         g_icustom_292 = iCustom(NULL, 0, "EMA_CROSSOVER_SIGNAL_2_(i)", E_FastMAPeriod, E_FastMAMethod, E_FastMAPrice, E_SlowMAPeriod, E_SlowMAMethod, E_SlowMAPrice, E_Confirm, 1, gi_308);
         li_8 = FALSE;
         li_12 = FALSE;
         switch (FF_On) {
         case 0:
            li_8 = TRUE;
            li_12 = TRUE;
            break;
         case 1:
            ld_20 = Volume[gi_308] * (iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308) - iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 1));
            ld_28 = (Volume[gi_308 + 1]) * (iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 1) - iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 2));
            if (ld_20 > FF_Level) li_8 = TRUE;
            if (ld_20 < -FF_Level) li_12 = TRUE;
            break;
         case 2:
            ld_20 = Volume[gi_308] * (iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308) - iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 1));
            ld_28 = (Volume[gi_308 + 1]) * (iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 1) - iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 2));
            if (ld_20 > FF_Level && ld_28 <= FF_Level) li_8 = TRUE;
            if (ld_20 < (-FF_Level) && ld_28 >= (-FF_Level)) li_12 = TRUE;
         }
         if (g_icustom_284 != EMPTY_VALUE && li_8) {
            if ((g_icustom_260 != 0.0 && BuyOnGreen) || (g_icustom_268 != 0.0 && BuyOnBlue) || (g_icustom_252 != 0.0 && BuyOnRed) || (g_icustom_276 != 0.0 && BuyOnChoc)) {
               if (g_icustom_244 > T_Level_1_Value || !T_Level_1_Check && g_icustom_244 < T_Level_2_Value || !T_Level_2_Check) {
                  g_ibuf_324[gi_308] = Low[gi_308] - gd_300;
                  if (g_ibuf_332[gi_308] <= 0.0) g_ibuf_332[gi_308] = 1;
                  else g_ibuf_332[gi_308]++;
               }
            }
         }
         if (g_icustom_292 != EMPTY_VALUE && li_12) {
            if ((g_icustom_260 != 0.0 && SellOnGreen) || (g_icustom_268 != 0.0 && SellOnBlue) || (g_icustom_252 != 0.0 && SellOnRed) || (g_icustom_276 != 0.0 && SellOnChoc)) {
               if (g_icustom_244 < (-T_Level_1_Value) || !T_Level_1_Check && g_icustom_244 > (-T_Level_2_Value) || !T_Level_2_Check) {
                  g_ibuf_328[gi_308] = High[gi_308] + gd_300;
                  if (g_ibuf_332[gi_308] >= 0.0) g_ibuf_332[gi_308] = -1;
                  else g_ibuf_332[gi_308]--;
               }
            }
         }
      }
      break;
   case 3:
      for (gi_308 = li_0 - 1; gi_308 >= 0; gi_308--) {
         g_ibuf_324[gi_308] = EMPTY_VALUE;
         g_ibuf_328[gi_308] = EMPTY_VALUE;
         g_ibuf_332[gi_308] = g_ibuf_332[gi_308 + 1];
         g_icustom_260 = iCustom(NULL, 0, "MACD_ELDER_X_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, 0, gi_308);
         g_icustom_268 = iCustom(NULL, 0, "MACD_ELDER_X_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, 1, gi_308);
         g_icustom_252 = iCustom(NULL, 0, "MACD_ELDER_X_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, 2, gi_308);
         g_icustom_276 = iCustom(NULL, 0, "MACD_ELDER_X_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, 3, gi_308);
         g_icustom_244 = iCustom(NULL, 0, "MACD_ELDER_X_(i)", T_FastMA_Period, T_FastMA_Method, T_FastMA_Price, T_SlowMA_Period, T_SlowMA_Method, T_SlowMA_Price, T_SignalMA_Period, T_SignalMA_Method, gi_312, gi_308);
         g_icustom_284 = iCustom(NULL, 0, "EMA_CROSSOVER_SIGNAL_2_(i)", E_FastMAPeriod, E_FastMAMethod, E_FastMAPrice, E_SlowMAPeriod, E_SlowMAMethod, E_SlowMAPrice, E_Confirm, 0, gi_308);
         g_icustom_292 = iCustom(NULL, 0, "EMA_CROSSOVER_SIGNAL_2_(i)", E_FastMAPeriod, E_FastMAMethod, E_FastMAPrice, E_SlowMAPeriod, E_SlowMAMethod, E_SlowMAPrice, E_Confirm, 1, gi_308);
         li_8 = FALSE;
         li_12 = FALSE;
         switch (FF_On) {
         case 0:
            li_8 = TRUE;
            li_12 = TRUE;
            break;
         case 1:
            ld_20 = Volume[gi_308] * (iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308) - iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 1));
            ld_28 = (Volume[gi_308 + 1]) * (iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 1) - iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 2));
            if (ld_20 > FF_Level) li_8 = TRUE;
            if (ld_20 < -FF_Level) li_12 = TRUE;
            break;
         case 2:
            ld_20 = Volume[gi_308] * (iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308) - iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 1));
            ld_28 = (Volume[gi_308 + 1]) * (iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 1) - iMA(NULL, 0, FF_Period, 0, FF_MAMethod, FF_Price, gi_308 + 2));
            if (ld_20 > FF_Level && ld_28 <= FF_Level) li_8 = TRUE;
            if (ld_20 < (-FF_Level) && ld_28 >= (-FF_Level)) li_12 = TRUE;
         }
         if (g_icustom_284 != EMPTY_VALUE && li_8) {
            if ((g_icustom_260 != 0.0 && BuyOnGreen) || (g_icustom_268 != 0.0 && BuyOnBlue) || (g_icustom_252 != 0.0 && BuyOnRed) || (g_icustom_276 != 0.0 && BuyOnChoc)) {
               if (g_icustom_244 > T_Level_1_Value || !T_Level_1_Check && g_icustom_244 < T_Level_2_Value || !T_Level_2_Check) {
                  g_ibuf_324[gi_308] = Low[gi_308] - gd_300;
                  if (g_ibuf_332[gi_308] <= 0.0) g_ibuf_332[gi_308] = 1;
                  else g_ibuf_332[gi_308]++;
               }
            }
         }
         if (g_icustom_292 != EMPTY_VALUE && li_12) {
            if ((g_icustom_260 != 0.0 && SellOnGreen) || (g_icustom_268 != 0.0 && SellOnBlue) || (g_icustom_252 != 0.0 && SellOnRed) || (g_icustom_276 != 0.0 && SellOnChoc)) {
               if (g_icustom_244 < (-T_Level_1_Value) || !T_Level_1_Check && g_icustom_244 > (-T_Level_2_Value) || !T_Level_2_Check) {
                  g_ibuf_328[gi_308] = High[gi_308] + gd_300;
                  if (g_ibuf_332[gi_308] >= 0.0) g_ibuf_332[gi_308] = -1;
                  else g_ibuf_332[gi_308]--;
               }
            }
         }
      }
   }
   for (gi_308 = li_0 - 1; gi_308 >= 0; gi_308--) {
      g_ibuf_316[gi_308] = EMPTY_VALUE;
      g_ibuf_320[gi_308] = EMPTY_VALUE;
      if (g_ibuf_324[gi_308] != EMPTY_VALUE)
         if (g_ibuf_332[gi_308] >= ArrowNumFrom && g_ibuf_332[gi_308] <= ArrowNumTo || ArrowNumTo == 0) g_ibuf_316[gi_308] = g_ibuf_324[gi_308];
      if (g_ibuf_328[gi_308] != EMPTY_VALUE)
         if (g_ibuf_332[gi_308] <= (-ArrowNumFrom) && g_ibuf_332[gi_308] >= (-ArrowNumTo) || ArrowNumTo == 0) g_ibuf_320[gi_308] = g_ibuf_328[gi_308];
   }
   return (0);
}

int PTA(int ai_0) {
   switch (ai_0) {
   case 1:
      return (4);
   case 5:
      return (6);
   case 15:
      return (8);
   case 30:
      return (13);
   case 60:
      return (17);
   case 240:
      return (40);
   case 1440:
      return (70);
   case 10080:
      return (150);
   case 43200:
      return (300);
   }
   return (0);
}
