#property indicator_separate_window
#property indicator_levelcolor Crimson
#property indicator_buffers 1
#property indicator_color1 Lime
#property indicator_level1 0.03
#property indicator_level2 -0.06

extern bool Alerts_On = TRUE;
extern bool Alerts_EOB = TRUE;
extern double Alert_Trigger_Level_1 = 0.03;
extern double Alert_Trigger_Level_2 = 0.03;
extern int ExtForcePeriod = 13;
extern int ExtForceMAMethod = 0;
extern int ExtForceAppliedPrice = 0;
extern bool FI_DisplayValue_On = TRUE;
extern int FI_Value_X = 930;
extern int FI_Value_Y = 40;
double g_ibuf_124[];
double gda_128[3];
bool gba_132[3];

int init() {
   string ls_0;
   IndicatorShortName("==-3==");
   SetIndexBuffer(0, g_ibuf_124);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   IndicatorShortName(ls_0);
   SetIndexLabel(0, ls_0);
   SetIndexDrawBegin(0, ExtForcePeriod);
   gda_128[1] = Alert_Trigger_Level_1;
   gda_128[2] = Alert_Trigger_Level_2;
   gba_132[1] = 1;
   gba_132[2] = 1;
   return (0);
}

int start() {
   color l_color_12;
   double l_window_20;
   int li_4 = IndicatorCounted();
   if (Bars <= ExtForcePeriod) return (0);
   if (li_4 > ExtForcePeriod) li_4--;
   int li_0 = Bars - li_4;
   for (int li_8 = li_0; li_8 >= 0; li_8--) {
      Print(li_8);
      g_ibuf_124[li_8] = Volume[li_8] * (iMA(NULL, 0, ExtForcePeriod, 0, ExtForceMAMethod, ExtForceAppliedPrice, li_8) - iMA(NULL, 0, ExtForcePeriod, 0, ExtForceMAMethod, ExtForceAppliedPrice, li_8 +
         1));
      if (FI_DisplayValue_On) {
         if (g_ibuf_124[li_8] > 0.0) l_color_12 = Blue;
         else l_color_12 = Red;
         ObjectDelete("PipeValue");
         ObjectCreate("PipeValue", OBJ_LABEL, WindowFind("FI"), 0, 0);
         ObjectSet("PipeValue", OBJPROP_CORNER, 0);
         ObjectSet("PipeValue", OBJPROP_XDISTANCE, FI_Value_X);
         ObjectSet("PipeValue", OBJPROP_YDISTANCE, FI_Value_Y);
         ObjectSetText("PipeValue", DoubleToStr(g_ibuf_124[li_8], 4), 22, "Arial Bold", l_color_12);
      }
      if (Alerts_On && li_8 == Alerts_EOB) {
         for (int li_16 = 1; li_16 < 3; li_16++) {
            l_window_20 = gda_128[li_16];
            if (MathAbs(g_ibuf_124[li_8]) > l_window_20) {
               if (gba_132[li_16]) {
                  Alert("ForceIndex threshold ", li_16, " exceeded... (M", Period(), " ", Symbol(), ")");
                  Comment(MathAbs(g_ibuf_124[1]));
                  gba_132[li_16] = 0;
               }
            } else gba_132[li_16] = 1;
         }
      }
   }
   return (0);
}
